import { IParameter } from "../Project/ProjectSubmitWork/interface";
export const getCustomTemplateParameterCheckResult = (
  parameter: IParameter,
  value: string
): {
  error: boolean;
  helperText: string;
} => {
  let error = false;
  let helperText = "";
  // 表单校验
  if (parameter.required) {
    // 提交任务时不展示
    if (parameter.hidden) {
      if (Array.isArray(value)) {
        if (value.length === 0) {
          error = true;
          helperText = "该参数为必填，您必须为该参数赋予默认值";
        }
      } else if (value === "" || value === null || value === undefined) {
        error = true;
        helperText = "该参数为必填，您必须为该参数赋予默认值";
      }
    }
  }
  if (parameter.validators.length > 0) {
    parameter.validators.forEach((validator) => {
      const reg = new RegExp(validator.regex);
      if (!reg.test(value)) {
        error = true;
        helperText = validator.message;
      }
    });
  }
  return {
    error,
    helperText,
  };
};
